#ifndef __MUSIC__
#define __MUSIC__

#ifdef __USE_MIDAS__
#include "midas/midas.h"
typedef gmpModule*      musMODULE;
typedef unsigned        musSAMPLE;
#endif

#ifdef __USE_MIKMOD__
#include "mikmod/mikmod.h"
typedef UNIMOD*         musMODULE;
typedef SAMPLE*         musSAMPLE;
#endif

#include "misc.h"

void musInitMusic(void);
void musInitCard( int musiccard );
void musLoadModule( char* name );
void musSetModule( uchar* );
void musFreeModule( uchar* gm );
void musStartMusic();
void musStopMusic();
musSAMPLE musLoadSample( char* name );
void musPlaySample( musSAMPLE s, uchar volume, uchar panning, int frequency );
void musFreeSample( musSAMPLE );
//  void getMusicInfo( int* pattern, int* row );
void musCloseMusic();
//void musLoadConfig( char* filename );
//void musSaveConfig( char* filename );
int musChooseCard();
void musSetVolume(int vol); //0..63
int musGetVolume();

extern int musInitialized, musPlaying;

#endif