#ifndef __PARTS__
#define __PARTS__

#include "video.h"
#include "image.h"
#include "poly2d.h"
#include "3d.h"
#include "font.h"

#define N_FIGS    3

extern vidRGB pal[256];
extern PAGE color, bw, vpage1, vpage2, vpage;
extern Image *titlepic, *dither, *circle, *colortext, *linepic;
extern int lx,ly,lxs,lys,ll,lr,lls,lrs;
extern short* zbuffer;
extern TPoly2D *fire1, *fire2;
extern FacedObject spider;
extern Font* font;
extern FacedObject *figs[N_FIGS];

void FillScanLine( uchar* offset, uint l, int ls );
#pragma aux FillScanLine = \
"mov ecx,vidSizeX"\
"add ecx,esi"\
"_loop:"\
"shld edx,eax,8"\
"add eax,ebx"\
"shld edx,eax,8"\
"add eax,ebx"\
"shld edx,eax,8"\
"add eax,ebx"\
"shld edx,eax,8"\
"add eax,ebx"\
"bswap edx"\
"mov [esi],edx"\
"add esi,4"\
"cmp esi,ecx"\
"jl _loop"\
parm [esi] [eax] [ebx]\
modify [ecx edx]

void partInit();
void partDone();
void partFire( uint secs );
void partFace( uint secs );
void partTitle( uint secs );
void partTrees( uint secs );
void partCubes( uint secs );
void partFigs( uint secs );
void partIndy( uint secs );
void partScroll( uint secs );

void fillLine( int Y, int X1, int X2, uchar color, PAGE page );
void drawLine( PAGE page, int x1, int y1, int x2, int y2, uchar color );
void drawLine1( PAGE page, int x1, int y1, int x2, int y2, uchar color );
void drawLinePix( PAGE page, int x1, int y1, int x2, int y2, uchar color );

#endif