#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <math.h>

const double K = 1;

unsigned char header[32] = { 0x6D, 0x68, 0x77, 0x61, 0x6E, 0x68, 0x00, 0x04,
                             0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x64 };

struct vidRGB { unsigned char r,g,b; };

void main( int argc, char* argv[] ) {
  _fmode = O_BINARY;
  int from = open( argv[1], O_RDONLY );
  int to = creat( argv[2], 0 );
  write( to, header, 32 );
  vidRGB pal[256];
  lseek( from, 32, SEEK_SET );
  read( from, pal, 768 );
  int i;

  for( i=0; i<192; i++ ) {
    pal[i].r >>= 4; pal[i].r <<= 4;
    pal[i].g >>= 4; pal[i].g <<= 4;
    pal[i].b >>= 4; pal[i].b <<= 4;
  }

  for( i=192; i<256; i++ ) {
    pal[i].r = (i-192)*4;
    pal[i].g = (i-192)*3;
    pal[i].b = (i-192)*2;
  }

  vidRGB buf[256];
  for( i=0; i<256; i++ ) {
    printf( "r=%3d g=%3d b=%3d\n", (int)pal[i].r, (int)pal[i].g, (int)pal[i].b );
    for( int j=0; j<256; j++ ) {
      int tmp;
/*
      if(j<170) {
        tmp = (int)pal[i].r*j/128;
        buf[j].r = tmp > 255 ? 255 : tmp;
      }
      else {
        tmp = (int)pal[i].r*j/128+(int)pal[i].r*(j-128)/40;
        buf[j].r = tmp > 255 ? 255 : tmp;
      }
*/
      int k = sqrt( pow( ((j>>0)<<0)/256.0, 2) )*256;
      if(j>240) k=k*(1+(j-240)/15.0);
      tmp = (int)pal[i].r*k/128;
      buf[j].r = tmp > 255 ? 255 : tmp;
      tmp = (int)pal[i].g*k/128;
      buf[j].g = tmp > 255 ? 255 : tmp;
      tmp = (int)pal[i].b*k/128;
      buf[j].b = tmp > 255 ? 255 : tmp;
    }
    write( to, buf, 768 );
  }
  close(from);
  close(to);
}
