#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include <ctype.h>
#ifdef __OS2__
#define INCL_DOS
#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#define  _MEERROR_H_
#include <mmioos2.h>
#include <dive.h>
#include <fourcc.h>
#else
#include <conio.h>
#include <i86.h>
#include "svgakit\svga.h"
#include "svgakit\vesavbe.h"
#endif
#include "video.h"
#include "misc.h"
#include "music.h"

bool vidInitialized = false;
int frameCount = 0;

int vidSizeX=320, vidSizeY=240, vidPageSize, vidPageLength, vidBytesPerLine,
    vidMaxPage, vidHiResMode;

#define N_GAMMA 4
uchar cur_gamma, gamma[N_GAMMA][64];

#ifdef __OS2__

#define  IDD_SIZEDLG    666
#define  IDD_SPIN       667

#define  ID_ERROR       667
#define  ID_BLIT        668
#define  ID_SNAP        669
#define  ID_SETMODE     670
#define  ID_FPS         671

HWND      vidWindow,  hwndClient;
HAB       hab;
BOOL      physPalette;
LONG      cxWidthWindow;
LONG      cyHeightWindow;
HDIVE     hDive;
ULONG     diveBuffer = 0;
BOOL      needResize = FALSE;
HEV       endSem, syncSem;
BOOL      release_timeslices=0;

void OS2MsgBox(char* msg)
{
  ULONG foo;
  DosResetEventSem(syncSem,&foo);
  WinPostMsg( vidWindow, WM_COMMAND, (MPARAM)ID_ERROR, (MPARAM)msg );
  DosWaitEventSem(syncSem,SEM_INDEFINITE_WAIT);
}

MRESULT EXPENTRY SizeDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{

  switch(msg) {
    case WM_INITDLG: {
       WinSendDlgItemMsg( hwnd, IDD_SPIN, SPBM_SETLIMITS, (MPARAM)640, (MPARAM)320 );
       break;
    }
    case WM_COMMAND: {
      if( (SHORT)mp1 == DID_OK ) {
        WinSendDlgItemMsg( hwnd, IDD_SPIN, SPBM_QUERYVALUE, &vidSizeX, 0 );
        WinDismissDlg(hwnd, vidSizeX);
        break;
      }
    }
    default:
      return WinDefDlgProc(hwnd,msg,mp1,mp2);
  }
  return FALSE;
}

MRESULT EXPENTRY MyWindowProc ( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 ) {

  switch( msg ) {

    case WM_CHAR: {

      if( SHORT1FROMMP(mp1) & (KC_PREVDOWN|KC_KEYUP) ) break;

      switch( SHORT2FROMMP ( mp2 ) ) {
        case VK_ESC: {
          DosPostEventSem(endSem);
//          WinPostMsg ( hwnd, WM_QUIT, 0, 0 );
          break;
        }
        case VK_F5: {
          WinSendMsg ( hwnd, WM_COMMAND, (MPARAM)ID_SNAP, 0 );
          break;
        }
        case VK_F6: {
          SWP swp;
          WinQueryWindowPos(vidWindow,&swp);
          swp.cy = (swp.cx-WinQuerySysValue(HWND_DESKTOP, SV_CXSIZEBORDER)*2)*vidSizeY/vidSizeX+
                   WinQuerySysValue(HWND_DESKTOP, SV_CYSIZEBORDER)*2+
                   WinQuerySysValue(HWND_DESKTOP, SV_CYTITLEBAR);
          WinSetWindowPos( vidWindow,0,
                           ( (LONG)WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN) - swp.cx ) / 2,
                           ( (LONG)WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN) - swp.cy ) / 2,
                           swp.cx,swp.cy,SWP_MOVE|SWP_SIZE|SWP_SHOW|SWP_ACTIVATE );
          break;
        }
        case VK_F11: {
          cur_gamma = (cur_gamma+1)%N_GAMMA;
          vidSetPalette( vidCurrentPalette );
          break;
        }
        case VK_F12: {
          release_timeslices = !release_timeslices;
          break;
        }
      }
      break;
    }

    case WM_COMMAND: {

//      printf( "%d %d",mp1,mp2 );

      switch ( (int)mp1 ) {

        case ID_SNAP: {
          LONG      cxWindowPos;
          LONG      cyWindowPos;
          cxWindowPos = ( (LONG)WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN)
                          - cxWidthWindow ) / 2;
          cyWindowPos = ( (LONG)WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN)
                           - cyHeightWindow ) / 2;
          WinSetWindowPos ( vidWindow, HWND_TOP, cxWindowPos, cyWindowPos,
                            cxWidthWindow, cyHeightWindow,
                            SWP_MOVE | SWP_SIZE | SWP_ACTIVATE | SWP_SHOW );
          WinShowWindow( vidWindow, TRUE );
          break;
        }

        case ID_ERROR: {
          WinMessageBox( HWND_DESKTOP, HWND_DESKTOP,
                             (PSZ)mp2, PROJECT_NAME": Error", 0, MB_OK | MB_INFORMATION );
          DosPostEventSem(syncSem);
          break;
        }

        case IDD_SIZEDLG: {
          WinDlgBox( HWND_DESKTOP, HWND_DESKTOP, &SizeDlgProc, 0, IDD_SIZEDLG, 0 );
          DosPostEventSem(syncSem);
          break;
        }

        case ID_FPS: {
          char str[256];
          sprintf( str, PROJECT_NAME": %5.2f fps", *(double*)mp2 );
          WinSetWindowText( vidWindow, str );
          break;
        }

        case ID_SETMODE: {
          vidSizeX = vidBytesPerLine = (((int)mp2+3)/4)*4; vidSizeY = vidSizeX*3/4;
          vidPageSize = vidSizeX*vidSizeY;

          if( !diveBuffer ) DiveFreeImageBuffer ( hDive, diveBuffer );
          if ( DiveAllocImageBuffer ( hDive, &diveBuffer, FOURCC_LUT8,
                                      vidSizeX,vidSizeY, 0, 0 ) ) {
            error( "DIVE: cannot allocate image buffer" );
          }

          LONG cxWidthBorder = (LONG) WinQuerySysValue(HWND_DESKTOP, SV_CXSIZEBORDER);
          LONG cyWidthBorder = (LONG) WinQuerySysValue(HWND_DESKTOP, SV_CYSIZEBORDER);
          LONG cyTitleBar    = (LONG) WinQuerySysValue(HWND_DESKTOP, SV_CYTITLEBAR);

          cxWidthWindow  = vidSizeX + cxWidthBorder * 2;
          cyHeightWindow = vidSizeY + (cyWidthBorder * 2 + cyTitleBar );

          WinSendMsg( vidWindow, WM_VRNENABLED, 0, 0 );
          WinPostMsg ( hwnd, WM_COMMAND, (MPARAM)ID_SNAP, 0 );

          DosPostEventSem(syncSem);
          break;
        }

        default:
          return WinDefWindowProc ( hwnd, msg, mp1, mp2 );
      }
      break;
    }
/*
    case WM_MINMAXFRAME: {
      if( ((PSWP)mp1)->fl | (SWP_HIDE|SWP_MINIMIZE) ) {
*/
    case WM_VRNDISABLED: {
        DiveSetupBlitter ( hDive, 0 );
      }
      break;
    }

    case WM_VRNENABLED: {

      POINTL    pointl;
      SWP       swp;
      HRGN      hrgn;
      HPS       hps;
      RECTL     rcls[50];
      RGNRECT   rgnCtl;
      SETUP_BLITTER SetupBlitter;
      hps = WinGetPS ( hwnd );
      if ( !hps ) break;
      hrgn = GpiCreateRegion ( hps, 0L, NULL );
      if ( hrgn ) {
        WinQueryVisibleRegion ( hwnd, hrgn );
        rgnCtl.ircStart     = 0;
        rgnCtl.crc          = 50;
        rgnCtl.ulDirection  = 1;

        if ( GpiQueryRegionRects ( hps, hrgn, NULL, &rgnCtl, rcls) ) {
          WinQueryWindowPos ( hwndClient, &swp );
          pointl.x = swp.x;
          pointl.y = swp.y;
          WinMapWindowPoints ( vidWindow, HWND_DESKTOP, &pointl, 1 );
          SetupBlitter.ulStructLen = sizeof ( SETUP_BLITTER );
          SetupBlitter.fccSrcColorFormat = FOURCC_LUT8;
          SetupBlitter.ulSrcWidth = vidSizeX;
          SetupBlitter.ulSrcHeight = vidSizeY;
          SetupBlitter.ulSrcPosX = 0;
          SetupBlitter.ulSrcPosY = 0;
          SetupBlitter.fInvert = TRUE;
          SetupBlitter.ulDitherType = 0;

          SetupBlitter.fccDstColorFormat = FOURCC_SCRN;
          SetupBlitter.ulDstWidth = swp.cx;
          SetupBlitter.ulDstHeight = swp.cy;
          SetupBlitter.lDstPosX = 0;
          SetupBlitter.lDstPosY = 0;
          SetupBlitter.lScreenPosX = pointl.x;
          SetupBlitter.lScreenPosY = pointl.y;
          SetupBlitter.ulNumDstRects = rgnCtl.crcReturned;
          SetupBlitter.pVisDstRects = rcls;
          DiveSetupBlitter ( hDive, &SetupBlitter );
        }
        else DiveSetupBlitter ( hDive, 0 );

        GpiDestroyRegion( hps, hrgn );
      }
      WinReleasePS( hps );
      break;
    }


    case WM_REALIZEPALETTE: {
      DiveSetDestinationPalette ( hDive, 0, 0, 0 );
      break;
    }

    default:
      return WinDefWindowProc ( hwnd, msg, mp1, mp2 );
  }
  return ( FALSE );
}

int MessageLoop()
{
   ULONG     flCreate;             /* Window creation control flags        */
   QMSG      qmsg;                         /* Message from message queue           */
   HMQ       hmq;                          /* Message queue handle                 */

   hab = WinInitialize ( 0 );
   hmq = WinCreateMsgQueue ( hab, 0 );

   WinRegisterClass ( hab, PROJECT_NAME, MyWindowProc, 0, sizeof(ULONG) );
   flCreate =  FCF_TASKLIST | FCF_SYSMENU  | FCF_TITLEBAR /*| FCF_ICON*/ |
               FCF_SIZEBORDER | FCF_MINMAX | FCF_SHELLPOSITION;
   vidWindow = WinCreateStdWindow ( HWND_DESKTOP,
                                    WS_VISIBLE, &flCreate,
                                    PROJECT_NAME, PROJECT_NAME,
                                    WS_SYNCPAINT | WS_VISIBLE,
                                    0, 0, &hwndClient);
   WinShowWindow( vidWindow, FALSE );

   WinSetVisibleRegionNotify( hwndClient, TRUE );
   DosPostEventSem(syncSem);

//   DosSetPriority ( PRTYS_THREAD, PRTYC_REGULAR, 31, 0 );

   while ( WinGetMsg ( hab, &qmsg, 0, 0, 0 ) ) {
      WinDispatchMsg ( hab, &qmsg );
   }
   DiveSetupBlitter ( hDive, 0 );
   DosPostEventSem(endSem);
   WinSetVisibleRegionNotify ( hwndClient, FALSE );
   WinDestroyWindow ( vidWindow );
   WinDestroyMsgQueue ( hmq );
   WinTerminate ( hab );
   return 0;
}

#else

enum { vidMode13, vidModeX, vidModeLinear } vidModeType;
bool PageAllocated[16] = {true,false};

#define SC_INDEX        0x3C4
#define MISC_OUTPUT     0x3C2
#define CRTC_INDEX      0x3D4
#define CHAIN4_OFF      0x604
#define ASYNC_RESET     0x100
#define SEQU_RESTART    0x300

enum {
  X320x200=1,
  X320x400,
  X360x200,
  X360x400,
  X320x240,
  X320x480,
  X360x240,
  X360x480,
  XMaxMode
} XModeNum;

uint W320[] = { 0x5F00, 0x4F01, 0x5002, 0x8203, 0x5404, 0x8005 };
uint W360[] = { 0x6B00, 0x5901, 0x5A02, 0x8E03, 0x5E04, 0x8A05 };

uint H200[] = { 0xBF06, 0x1F07, 0x9C10, 0x8E11, 0x8F12, 0x9615, 0xB916, 0x4109, 0x0014, 0xE317 };
uint H240[] = { 0x0D06, 0x3E07, 0xEA10, 0x8C11, 0xDF12, 0xE715, 0x0616, 0x4109, 0x0014, 0xE317 };
uint H400[] = { 0xBF06, 0x1F07, 0x9C10, 0x8E11, 0x8F12, 0x9615, 0xB916, 0x4009, 0x0014, 0xE317 };
uint H480[] = { 0x0D06, 0x3E07, 0xEA10, 0x8C11, 0xDF12, 0xE715, 0x0616, 0x4009, 0x0014, 0xE317 };

struct XMode {
  int x, y;
  uchar clock;
  int pagenum;
  uint* W;
  uint* H;
}

XModes[XMaxMode] = {
  { 0,   0,   0,    0, 0,    0  },
  { 320, 200, 0x63, 4, W320, H200 },
  { 320, 400, 0x63, 2, W320, H400 },
  { 360, 200, 0x67, 3, W360, H200 },
  { 360, 400, 0x67, 1, W360, H400 },
  { 320, 240, 0xE3, 3, W320, H240 },
  { 320, 480, 0xE3, 1, W320, H480 },
  { 360, 240, 0xE7, 2, W360, H240 },
  { 360, 480, 0xE7, 1, W360, H480 },
};

XMode* XCurrentMode;
int XCurrentPage=1;
PAGE XBuffer;

#endif

void vidInitVideo() {
#ifdef __OS2__

  DosCreateEventSem(0,&endSem,0,0);
  DosCreateEventSem(0,&syncSem,0,0);
  TID foo;
  DosCreateThread( &foo, (PFNTHREAD)MessageLoop, 0, 0L, 8192L);
  DosWaitEventSem(syncSem,SEM_INDEFINITE_WAIT);

   DIVE_CAPS DiveCaps = {0};
   FOURCC   fccFormats[100] = {0};
   DiveCaps.pFormatData = fccFormats;
   DiveCaps.ulFormatLength = 100;
   DiveCaps.ulStructLen = sizeof(DIVE_CAPS);
   if ( DiveQueryCaps ( &DiveCaps, DIVE_BUFFER_SCREEN )) {
     error( "DIVE: cannot query capabilities" );
   }
   if ( DiveCaps.ulDepth < 8 ) {
     error( "DIVE: at least 256-color capable display required" );



   }
   if ( DiveOpen ( &hDive, FALSE, 0 ) ) {
     error( "DIVE: cannot open" );
   }
   physPalette = DiveCaps.fccColorEncoding == FOURCC_LUT8;

#else
  SV_init();
  vidInitialized = true;
  union REGS regs;
  regs.w.ax = 3;
  int386( 0x10, &regs, &regs );
/*
  regs.h.bl=0; regs.w.ax = 0x1112;
  int386( 0x10, &regs, &regs );
*/
#endif

  for( int i=0; i<N_GAMMA; i++ ) {
    for( int j=0; j<64; j++ ) {
      int tmp = (1+(double)i/N_GAMMA)*j;
      if( tmp>63 ) tmp = 63;
      gamma[i][j]=tmp;
    }
  }

}

void vidSetVideoMode( int num ) {
#ifdef __OS2__
  ULONG foo;
  DosResetEventSem(syncSem,&foo);
  WinPostMsg( vidWindow, WM_COMMAND, (MPARAM)ID_SETMODE, (MPARAM)num );
  DosWaitEventSem(syncSem,SEM_INDEFINITE_WAIT);
#else
  if( num >= 0x100 && VBEVersion<0x200 ) {
    error( "VESA VBE 2.0+ with linear frame buffer support required" );
  }
  if( num == 0x13 ) {
    vidModeType = vidMode13;
    VBE_setVideoMode(num);
    maxx = 319;
    maxy = 199;
    bytesperline = 320;
    bitsperpixel = 8;
    maxpage = 0;
    pagesize = 64000;
    videoMem = (void*)0xA0000;
  }
  if( num < XMaxMode ) {
    vidModeType = vidModeX;
    XCurrentMode = &XModes[num];
    maxx = XCurrentMode->x-1;
    maxy = XCurrentMode->y-1;
    XBuffer = (PAGE)cmalloc( XCurrentMode->x*XCurrentMode->y );
    bytesperline = maxx+1;
    bitsperpixel = 8;
    maxpage = 0;
    pagesize = (maxy+1)*bytesperline;
    videoMem = (void*)0xA0000;
    vidModeType = vidModeX;
    VBE_setVideoMode(0x13);
    outpw( SC_INDEX, CHAIN4_OFF );
    outpw( SC_INDEX, ASYNC_RESET );
    outp( MISC_OUTPUT, XCurrentMode->clock );
    outpw( SC_INDEX, SEQU_RESTART );
    outp( CRTC_INDEX, 0x11 );
    outp( CRTC_INDEX+1, inp( CRTC_INDEX+1 ) & 0x7F );
    int i;
    for( i=0; i<sizeof(W320)/sizeof(uint); i++ ) {
      outpw( CRTC_INDEX, XCurrentMode->W[i] );
    }
    for( i=0; i<sizeof(H200)/sizeof(uint); i++ ) {
      outpw( CRTC_INDEX, XCurrentMode->H[i] );
    }
    outpw( CRTC_INDEX, ((bytesperline/8)<<8) + 0x13 );
    outpw( SC_INDEX, 0xF02 );
    memset( videoMem, 0, 64000 );
  }
  if( num > 0x100 && num < 0x5000 ) {
    vidModeType = vidModeLinear;
    if( !SV_setMode(num) ) {
      char str[256];
      sprintf( str, "Cannot set video mode #%x", num );
      error( str );
    }
  }
  vidSizeX = maxx+1;
  vidSizeY = maxy+1;
  vidPageLength = pagesize;
  vidBytesPerLine = bytesperline;
  vidPageSize = vidBytesPerLine*vidSizeY;
  vidMaxPage = maxpage+1;
/*
  printf( "vidSizeX=%d vidSizeY=%d vidPageSize=%d vidPageLength=%d\n"\
          "vidMaxPage=%d vidBytesPerLine=%d\n",
          vidSizeX, vidSizeY, vidPageSize, vidPageLength,
          vidMaxPage, vidBytesPerLine );
*/
#endif
}

void vidCloseVideo() {
#ifdef __OS2__
   if( WinIsWindow( hab, vidWindow ) ) {
     WinSendMsg ( vidWindow, WM_QUIT, 0L, 0L );
   }
   DiveFreeImageBuffer ( hDive, diveBuffer );
   DiveClose ( hDive );
#else
  if(vidInitialized) SV_restoreMode();
  union REGS regs;
  regs.w.ax = 3;
  int386( 0x10, &regs, &regs );
  if( *(uchar*)0x417 & 3 ) {
    printf( "Average frames per second: %5.2f\n",
            frameCount*miscTimerRes/miscTimer() );
  }
#endif
}

#ifdef __OS2__
#else
void vidPutChar( int c, int attr )
{
  union REGS regs;
  regs.h.ah = 3;
  regs.h.bh = 0;
  int386( 0x10, &regs, &regs );
  *(uchar*)(0xB8000+regs.h.dh*160+regs.h.dl*2+1) = attr;
  putch(c);
}
#endif

int vidChooseVideoMode() {
#ifdef __OS2__
  ULONG foo;

  DosResetEventSem(syncSem,&foo);
  if( WinIsWindow( hab, hwndClient ) ) WinPostMsg( vidWindow, WM_COMMAND, (MPARAM)IDD_SIZEDLG, 0 );
  DosWaitEventSem(syncSem,SEM_INDEFINITE_WAIT);

  vidHiResMode=VID_MAX_SIZE_X;
  return vidSizeX;
#else
int modes[256]={0}, maxmode=0;
VBE_modeInfo mi;
  union REGS regs;
  regs.w.ax = 3;
  int386( 0x10, &regs, &regs );
  cputs( " Choose video mode (ESC exits):\n\r\n\r" );
  cputs( " Approximate hardware requirements:\n\r" );
  cputs( " 320x200: 486-66, 2M free RAM   360x240: 486-100, 2M free RAM\n\r" );
  cputs( " 360x400: P5-100, 3M free RAM   640x480: P5-200,  4M free RAM\n\r\n\r" );
  putch(' ');
  vidPutChar( '0', 0x9 );
  cputs( ". 320x200x256 plain VGA\n\r\n\r" );
  modes['0']=0x13;
  int c='1'; int flag=0;
  cputs( " X-modes (VGA compatible) :\n\r" );
  putch(' ');
  int i;
  for(i=1; i<XMaxMode; i++, c++) {
    vidPutChar( c, 0x9 );
    cprintf( ". %dx%dx256 X-Mode   ", XModes[i].x, XModes[i].y );
    if( flag++%2 ) {
      cputs( "\n\r" );
      putch(' ');
    }
    modes[c]=i;
  }
  cputs( "\n\r SVGA modes (require VESA VBE 2.0+ but faster in the same resolution) :\n\r" );
  putch(' ');
  flag=0;
  for( ushort* mode=modeList; *mode != 0xFFFF; mode++ ) {
    if (!VBE_getModeInfo(*mode,&mi)) continue;
    if (mi.BitsPerPixel == 8 && mi.XResolution &&
        mi.XResolution <= VID_MAX_SIZE_X &&
        mi.YResolution <= VID_MAX_SIZE_Y &&
        ( (mi.ModeAttributes & vbeMdLinear) || haveVirtualBuffer ) ) {
      vidPutChar( c, 0x9 );
      modes[c]=*mode;
      char* type;
      if( mi.ModeAttributes & vbeMdLinear ) {
        modes[c] |= vbeLinearBuffer;
        type = "LFB  ";
      }
      else {
        useVirtualBuffer = true;
        type = "banked";
      }
      cprintf( ". %dx%dx256 %s   ", mi.XResolution, mi.YResolution, type );
      if( flag++%2 ) {
        cputs( "\n\r" );
        putch(' ');
      }
      if( c++ == '9' ) c = 'A';
    }
  }
  vidHiResMode=modes[c-1];
  cputs( "\n\r" );
  do {
    while( !kbhit() );
    c = toupper(getch());
    while( kbhit() ) getch();
  } while( !modes[c] && c != 27 );
  if( c == 27 ) error("User abort");
  return modes[c];
#endif
}

#ifdef __OS2__
#else
void vidWaitRetrace()
{
  while( inp(0x3dA) & 8 );
  while( !(inp(0x3dA) & 8) );
}
#endif

int vidBlackColor;
vidRGB vidCurrentPalette[256];

void vidSetPalette( vidRGB* pal ) {
  memcpy( vidCurrentPalette, pal, sizeof(vidCurrentPalette) );
#ifdef __OS2__
  ULONG auTable[256];
  for( int i=0; i<256; i++ ) auTable[i] = (PC_RESERVED<<24)|(gamma[cur_gamma][pal[i].red]<<18)|
                                                                                  (gamma[cur_gamma][pal[i].green]<<10)|
                                                                                  (gamma[cur_gamma][pal[i].blue]<<2);

  if( physPalette ) {
    static HPAL oldHpal = 0;
    HPAL hpal = GpiCreatePalette( hab, 0L, LCOLF_CONSECRGB, 256, auTable );
    HPS hps = WinGetPS(vidWindow);
    GpiSelectPalette(hps,hpal);
    ULONG foo ;
    WinRealizePalette(vidWindow,hps,&foo);
    if( oldHpal ) GpiDeletePalette(oldHpal);
    oldHpal = hpal;
    WinReleasePS(hps);
  }

  DiveSetSourcePalette(hDive, 0, 256, (PBYTE)auTable);
#else
//  if( vidModeType != vidModeLinear ) {
    vidWaitRetrace();
    outp(0x3c8,0);
    int minv=9999, vidBlackColor=0;
    for( int i=0; i<256; i++ ) {
      outp(0x3c9,gamma[cur_gamma][pal[i].red]);
      outp(0x3c9,gamma[cur_gamma][pal[i].green]);
      outp(0x3c9,gamma[cur_gamma][pal[i].blue]);
      if(minv>pal[i].red+pal[i].green+pal[i].blue) {
        minv=pal[i].red+pal[i].green+pal[i].blue;
        vidBlackColor = i;
      }
    }
/*
    printf( "vidBlackColor=%d, (%d,%d,%d)\n", vidBlackColor,
            pal[vidBlackColor].red, pal[vidBlackColor].green,
            pal[vidBlackColor].blue );
*/
    union REGS regs;
    regs.h.bh=vidBlackColor; regs.w.ax = 0x1001;
    int386( 0x10, &regs, &regs );
/*
  }
  else {
    SV_setPalette( start, num, pal, -1 );
  }
*/
#endif
}

PAGE vidAllocPage( bool inRAM ) {
#ifdef __OS2__
  {
#else
  if( inRAM || vidModeType != vidModeLinear ) {
    return (PAGE)cmalloc(vidPageSize);
  }
  else {
    for( int i=1; i<vidMaxPage; i++ ) {
      if( !PageAllocated[i] ) {
        PageAllocated[i] = true;
        return vidScreenPtr+vidPageLength*i;
      }
    }
#endif
    return (PAGE)cmalloc(vidPageSize);
  }
}

void vidFreePage( PAGE Page ) {
#ifdef __OS2__
  {
#else
  if( Page >= vidScreenPtr &&
      Page <= vidScreenPtr+vidPageLength*vidMaxPage ) {
    PageAllocated[ (Page-vidScreenPtr)/vidPageLength] = false;
  }
  else {
#endif
    cfree(Page);
  }
}

#ifdef __OS2__
#else
void __asmcopyx__();
#pragma aux __asmcopyx__ = \
"shr ecx,2"\
"loop1:"\
"mov ah,[esi+12]"\
"mov al,[esi+8]"\
"shl eax,16"\
"mov ah,[esi+4]"\
"mov al,[esi]"\
"add esi,16"\
"mov [edi],eax"\
"add edi,4"\
"dec ecx"\
"jnz loop1"

void __copyx__() { __asmcopyx__(); }

void vidCopyX( PAGE screen, PAGE frompage, int bytes );
#pragma aux vidCopyX = \
"shr ecx,2"\
"push esi"\
"push edi"\
"push ecx"\
"mov dx,3C4h"\
"mov ax,102h"\
"out dx,ax"\
"call __copyx__"\
"pop ecx"\
"pop edi"\
"pop esi"\
\
"inc esi"\
"push esi"\
"push edi"\
"push ecx"\
"mov dx,3C4h"\
"mov ax,202h"\
"out dx,ax"\
"call __copyx__"\
"pop ecx"\
"pop edi"\
"pop esi"\
\
"inc esi"\
"push esi"\
"push edi"\
"push ecx"\
"mov dx,3C4h"\
"mov ax,402h"\
"out dx,ax"\
"call __copyx__"\
"pop ecx"\
"pop edi"\
"pop esi"\
\
"inc esi"\
"mov dx,3C4h"\
"mov ax,802h"\
"out dx,ax"\
"call __copyx__"\
parm [edi] [esi] [ecx]\
modify [eax ecx edx];

void vidCopyPageX( PAGE screen, PAGE frompage )
{
  for( int i=0; i<vidSizeY/2; i++ ) {
    vidCopyX( screen+i*vidBytesPerLine/2, frompage+i*vidBytesPerLine*2,
              vidBytesPerLine*2);
  }
}
#endif

void _vidCopyPage( PAGE topage, PAGE frompage );
#pragma aux _vidCopyPage = \
"mov ecx,[vidPageSize]"\
"shr ecx,2"\
"cld"\
"rep movsd"\
parm [edi] [esi]\
modify exact [ecx];

void vidCopyPage( PAGE frompage, PAGE topage )
{
  _vidCopyPage( frompage, topage );
}

void _vidCopyPageT( PAGE topage, PAGE frompage );
#pragma aux _vidCopyPageT = \
"mov ecx,[vidPageSize]"\
"_loop:"\
"mov al,[esi]"\
"or al,al"\
"jz no_mov"\
"mov [edi],al"\
"no_mov:"\
"inc esi"\
"inc edi"\
"dec ecx"\
"jnz _loop"\
parm [edi] [esi]\
modify exact [ecx];

void vidCopyPageT( PAGE frompage, PAGE topage )
{
  _vidCopyPageT( frompage, topage );
}

void vidShowPage( PAGE Page )
{
  frameCount++;
#ifdef __OS2__

   static prevTime = 0;
   if( WinIsWindow( hab, vidWindow ) ) {
     ULONG    foo;
     char* Buffer;
     DiveBeginImageBufferAccess ( hDive, diveBuffer, &Buffer, &foo, &foo );
     for( int i=0; i<vidSizeY; i++ )
       memcpy( Buffer+vidBytesPerLine*i, Page+vidBytesPerLine*(vidSizeY-i-1), vidBytesPerLine );
     DiveEndImageBufferAccess ( hDive, diveBuffer );
     DiveBlitImage ( hDive, diveBuffer, DIVE_BUFFER_SCREEN );
     if( !(frameCount%10) ) {
       if( prevTime ) {
         static double fps;
         fps = 10/((miscTimer()-prevTime)/miscTimerRes);
         WinPostMsg( vidWindow, WM_COMMAND, (MPARAM)ID_FPS, &fps );
       }
       prevTime = miscTimer();
     }
   }

  ULONG count;
  DosQueryEventSem(endSem,&count);
  if (count) {
    Shutdown();
    exit(1);
  }
  if( release_timeslices ) DosSleep(0);
#else
  static time=0;
  if( kbhit() ) {
    int c;
    while( kbhit() ) c=getch();
    switch(c) {
      case 133: {
        cur_gamma = (cur_gamma+1)%N_GAMMA;
        vidSetPalette( vidCurrentPalette );
        break;
      }
      case 27: {
        Shutdown();
        exit(1);
        break;
      }
      case '+': {
        if( musGetVolume() < 53 )
          musSetVolume( musGetVolume()+10 );
        else
          musSetVolume(63);
        break;
      }
      case '-': {
        if( musGetVolume() > 10 )
          musSetVolume( musGetVolume()-10 );
        else
          musSetVolume(0);
        break;
      }
    }
  }
  if( *(uchar*)0x417 & 3 ) {
    int fps = miscTimerRes/(miscTimer()-time);
    for( int i=0; i<fps; i++ ) {
      int c= i<8 ? 255 : 254;
      Page[i*3]=255; Page[i*3+1]=255;
      Page[i*3+vidBytesPerLine]=255; Page[i*3+1+vidBytesPerLine]=255;
    }
  }
  time=miscTimer();
  switch( vidModeType ) {
    case vidModeLinear: {
      if( Page >= vidScreenPtr &&
          Page <= vidScreenPtr+vidPageLength*vidMaxPage ) {
        SV_setVisualPage( (Page-(PAGE)vidScreenPtr)/vidPageLength, true );
      }
      else {
        vidCopyPage( (PAGE)vidScreenPtr, Page );
        SV_setVisualPage( 0, true );
      }
      break;
    }
    case vidMode13: {
      vidWaitRetrace();
      vidCopyPage( (PAGE)vidScreenPtr, Page );
      break;
    }
    case vidModeX: {
      if( XCurrentMode->pagenum > 1 ) {
        vidCopyPageX( (PAGE)(vidScreenPtr+XCurrentPage*vidSizeX*vidSizeY/4), Page );
        vidWaitRetrace();
        outpw( CRTC_INDEX, (((XCurrentPage*vidSizeX*vidSizeY/4)>>8)<<8)+0xC );
        outpw( CRTC_INDEX, (((XCurrentPage*vidSizeX*vidSizeY/4))<<8)+0xD );
        XCurrentPage = (++XCurrentPage)%XCurrentMode->pagenum;
        break;
      }
      else {
        vidWaitRetrace();
        vidCopyPageX( (PAGE)vidScreenPtr, Page );
      }
    }
  }
#endif
}

void vidClearPage( PAGE Page, uchar value ) {
  memset( Page, value, vidPageSize );
}

static int total;

void vidFlipPage( PAGE* vpage, PAGE vpage1, PAGE vpage2 )
{
  vidShowPage(*vpage);
  *vpage = PAGE( (int)vpage1 + (int)vpage2 - (int)*vpage );
}


