#ifndef __VIDEO__
#define __VIDEO__

#ifdef __OS2__
#define INCL_DOS
#define INCL_WIN
#include <os2.h>
#else
#include "svgakit/svga.h"
#include "svgakit/vesavbe.h"
#endif

#include "types.h"

#define VID_MAX_SIZE_X  640
#define VID_MAX_SIZE_Y  480

#ifdef __OS2__
struct vidRGB { uchar red,green,blue,foo; };
#else
typedef VBE_palette vidRGB;
#endif
typedef uchar* PAGE;

#ifdef __OS2__
extern HWND vidWindow;
void OS2MsgBox(char* msg);
#else
#define vidScreenPtr    ((uchar*)videoMem)
#endif

extern "C" int vidSizeX, vidSizeY, vidPageSize, vidBytesPerLine, vidMaxPage;
extern int vidHiResMode;
                                           
extern int vidBlackColor;
extern vidRGB vidCurrentPalette[256];

#define vidScaleX(x) ((x)*vidSizeX/VID_MAX_SIZE_X)
#define vidScaleY(y) ((y)*vidSizeY/VID_MAX_SIZE_Y)

void vidInitVideo();
void vidSetVideoMode( int num );
void vidCloseVideo();
int vidChooseVideoMode();
void vidSetPalette( vidRGB* pal );
PAGE vidAllocPage( bool inRAM );
void vidFreePage( PAGE Page );
void vidShowPage( PAGE Page );
void vidFlipPage( PAGE* vpage, PAGE vpage1, PAGE vpage2 );
void vidCopyPage( PAGE topage, PAGE frompage );
void vidCopyPageT( PAGE topage, PAGE frompage );
void vidClearPage( PAGE Page, uchar value=0 );

extern "C" {
void vidDitherPage( PAGE colorpage, PAGE bwpage, PAGE topage,
                            PAGE dithertable );
#pragma aux vidDitherPage parm [eax] [edi] [edx] [esi] modify [ebx ecx];
}

void vidPutChar( int c, int attr );

#endif